//
// jMax
// Copyright (C) 1994, 1995, 1998, 1999 by IRCAM-Centre Georges Pompidou, Paris, France.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1
// of the License, or (at your option) any later version.
// 
// See file COPYING.LIB for further informations on licensing terms.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 

package ircam.jmax.editors.sequence.menus;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import ircam.jmax.toolkit.*;
import ircam.jmax.toolkit.actions.*;

import ircam.jmax.editors.sequence.*;
import ircam.jmax.editors.sequence.actions.*;
import ircam.jmax.editors.sequence.track.*;

public class MonoTrackPopupMenu extends TrackBasePopupMenu 
{
  JRadioButtonMenuItem peaksItem, stepsItem, breaksItem;
  
  public MonoTrackPopupMenu( MonoTrackEditor editor, boolean isInSequence)
  {
    super(editor, isInSequence);
  }

  boolean addRangeMenu()
  {
    JMenuItem item = new JMenuItem("Range");
    item.addActionListener(new ActionListener(){
	public void actionPerformed(ActionEvent e)
	{
	  ChangeRangeDialog.changeRange(target.getTrack(), target.getGraphicContext().getFrame(),
					SwingUtilities.convertPoint(target, x, y, target.getGraphicContext().getFrame()));
	}
      });
    add(item);
  
    return true;
  }

  boolean addViewMenu()
  {
    ButtonGroup viewsMenuGroup = new ButtonGroup();

    peaksItem = new JRadioButtonMenuItem("Peaks view");
    peaksItem.addActionListener(new SetViewAction(MonoTrackEditor.PEAKS_VIEW, target));
    viewsMenuGroup.add(peaksItem);
    add(peaksItem);    
    
    stepsItem = new JRadioButtonMenuItem("Steps view");
    stepsItem.addActionListener(new SetViewAction(MonoTrackEditor.STEPS_VIEW, target));
    viewsMenuGroup.add(stepsItem);
    add(stepsItem);
    
    breaksItem= new JRadioButtonMenuItem("BreakPoints view");
    breaksItem.addActionListener(new SetViewAction(MonoTrackEditor.BREAK_POINTS_VIEW, target));
    viewsMenuGroup.add(breaksItem);
    add(breaksItem);
    
    peaksItem.setSelected(true);
    
    return true;
  }

  void updateViewMenu()
  {
    switch( target.getViewMode())
      {
      case MonoTrackEditor.STEPS_VIEW:
	stepsItem.setSelected(true);
	break;
      case MonoTrackEditor.BREAK_POINTS_VIEW:
	breaksItem.setSelected(true);
	break;
      case MonoTrackEditor.PEAKS_VIEW:
      default:
	peaksItem.setSelected(true);
	break;
      }
  }
}











